#if defined(__linux__)
#if defined(__sh__)

/*
 * Use Linux system call.
 */

#define SYS_exit          1
#define SYS_fork          2
#define SYS_wait4       114
#define SYS_kill         37
#define SYS_execve       11

#define SYS_read          3
#define SYS_write         4
#define SYS_open          5
#define SYS_close         6

#define SYS_dup          41
#define SYS_pipe         42
#define SYS_dup2         63
#define SYS_pipe2       331

#define SYS_sigaction    67 /* rt_sigaction is 174 */
#define SYS_sigprocmask 126 /* rt_sigprocmask is 175 */

#define SYS_chdir        12
#define SYS_ioctl        54
#define SYS_brk          45
#define SYS_getcwd      183

	.section .text

	.globl	____exit
	.type	____exit, %function
____exit:
	mov	#SYS_exit, r3
	trapa	#0x17
	rts
	nop

	.globl	___fork
	.type	___fork, %function
___fork:
	mov	#SYS_fork, r3
	trapa	#0x17
	rts
	nop

	.globl	___wait4
	.type	___wait4, %function
___wait4:
	mov	#SYS_wait4, r3
	trapa	#0x17
	rts
	nop

	.globl	___kill
	.type	___kill, %function
___kill:
	mov	#SYS_kill, r3
	trapa	#0x17
	rts
	nop

	.globl	___execve
	.type	___execve, %function
___execve:
	mov	#SYS_execve, r3
	trapa	#0x17
	rts
	nop

	.globl	___read
	.type	___read, %function
___read:
	mov	#SYS_read, r3
	trapa	#0x17
	rts
	nop

	.globl	___write
	.type	___write, %function
___write:
	mov	#SYS_write, r3
	trapa	#0x17
	rts
	nop

	.globl	___open
	.type	___open, %function
___open:
	mov	#SYS_open, r3
	trapa	#0x17
	rts
	nop

	.globl	___close
	.type	___close, %function
___close:
	mov	#SYS_close, r3
	trapa	#0x17
	rts
	nop

	.globl	___dup
	.type	___dup, %function
___dup:
	mov	#SYS_dup, r3
	trapa	#0x17
	rts
	nop

	.globl	___pipe
	.type	___pipe, %function
___pipe:
	mov	#SYS_pipe, r3
	trapa	#0x17
	rts
	nop

	.globl	___dup2
	.type	___dup2, %function
___dup2:
	mov	#SYS_dup2, r3
	trapa	#0x17
	rts
	nop

	.globl	___pipe2
	.type	___pipe2, %function
___pipe2:
	mov	#SYS_pipe2, r3
	trapa	#0x17
	rts
	nop

	.globl	___sigaction
	.type	___sigaction, %function
___sigaction:
	mov	#SYS_sigaction, r3
	trapa	#0x17
	rts
	nop

	.globl	___sigprocmask
	.type	___sigprocmask, %function
___sigprocmask:
	mov	#SYS_sigprocmask, r3
	trapa	#0x17
	rts
	nop

	.globl	___chdir
	.type	___chdir, %function
___chdir:
	mov	#SYS_chdir, r3
	trapa	#0x17
	rts
	nop

	.globl	___ioctl
	.type	___ioctl, %function
___ioctl:
	mov	#SYS_ioctl, r3
	trapa	#0x17
	rts
	nop

	.globl	___brk
	.type	___brk, %function
___brk:
	mov	#SYS_brk, r3
	trapa	#0x17
	rts
	nop

	.globl	_____getcwd
	.type	_____getcwd, %function
_____getcwd:
	mov	#SYS_getcwd, r3
	trapa	#0x17
	rts
	nop
#endif
#endif
